var m_toolbutton = false;
var m_wasinited = false;
var m_commonprefs = false;
var m_pb_prefs = false;
var m_pb_logger = false;
var m_pb_rObserver = {
    observe : function(subject, topic, data) { proxybutton_setButtonFromPreference(); }
};
var m_pb_pbi;

function proxybutton_switchProxy() {
    proxybutton_log(1, 'called switchProxy()');
    if (!m_wasinited || !m_toolbutton) {
        proxybutton_init();
    }

    var nCurProxyType = m_commonprefs.getIntPref("network.proxy.type");
    if (nCurProxyType == 0) {
        proxybutton_setManual();
    } else {
        proxybutton_setDirect();
    }
}

function proxybutton_init() {
    if (!m_pb_logger) {
        try {
            var logMngr = Components.classes["@mozmonkey.com/debuglogger/manager;1"].
                    getService(Components.interfaces.nsIDebugLoggerManager); 
            m_pb_logger = logMngr.registerLogger("proxybutton");
        } catch (exErr) {
            m_pb_logger = false;
        }
    }
    
    proxybutton_log(1, 'called init()');
    if (!m_commonprefs) {
    	proxybutton_initPrefObjects();
    }
    proxybutton_log(1, 'checking prefs for existance');
    proxybutton_checkPreferencesExist();
    if (!m_toolbutton) {
        proxybutton_log(1, 'looking for button element');
        if (document.getElementById("proxybutton-button")) {
            m_toolbutton = document.getElementById("proxybutton-button");
        } else if (document.getElementById("proxybutton-button-tb")) {
            m_toolbutton = document.getElementById("proxybutton-button-tb");
        } else {
            m_toolbutton = document.getElementById("proxybutton-button-tb-msg");
        }
    } else {
        proxybutton_log(1, 'skipping button element search');
    }
    if (!m_wasinited) {
        proxybutton_log(1, 'initializing observer');
        proxybutton_log(1, 'getting service');
        var prefService = Components.classes["@mozilla.org/preferences-service;1"].
            getService(Components.interfaces.nsIPrefService);
        proxybutton_log(1, 'getting branch');
        var rBranch = prefService.getBranch("network.");
        proxybutton_log(1, 'quering interface');
        m_pb_pbi = rBranch.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
        proxybutton_log(1, 'adding observer');
        m_pb_pbi.addObserver("proxy", m_pb_rObserver, false);
        
        m_wasinited = true;
    } else {
        proxybutton_log(1, 'skipping observers init');
    }
    
    proxybutton_log(1, 'setting from prefs');
    proxybutton_setButtonFromPreference();
    proxybutton_log(1, 'init completed');
}

function proxybutton_destroy() {
    proxybutton_log(1, 'Calling destroy');
    m_pb_pbi.removeObserver("proxy", m_pb_rObserver);
}

function proxybutton_setButtonFromPreference() {
    var nCurProxyType = m_commonprefs.getIntPref("network.proxy.type");
    if (nCurProxyType == 0) {
        proxybutton_changeImage(0);
    } else {
        proxybutton_changeImage(1);
    }

}

function proxybutton_setDirect() {
    proxybutton_log(1, 'called setDirect()');
    m_commonprefs.setIntPref("network.proxy.type", 0);
    var swOff = m_pb_prefs.getBoolPref('launch_swoff');
    if (m_pb_prefs.getBoolPref('launch_swoff')) {
        var runcmd;
        if (m_pb_prefs.getBoolPref('launch_swoff_same')) {
            runcmd = m_pb_prefs.getCharPref('launch_swon_cmd');
        } else {
            runcmd = m_pb_prefs.getCharPref('launch_swoff_cmd');
        }
        proxybutton_startApp(runcmd);
    }
}

function proxybutton_changeImage(nToType) {
    var sPrefix;

    proxybutton_log(1, 'called changeImage()');
    if (nToType==0) {
        m_toolbutton.setAttribute('pbstatus', 'off');
        m_toolbutton.setAttribute('tooltiptext', 'Turn proxy on');
    } else {
        m_toolbutton.setAttribute('pbstatus', 'on');
        m_toolbutton.setAttribute('tooltiptext', 'Turn proxy off');
    }
}

function proxybutton_setManual() {
    proxybutton_log(1, 'called setManual()');
    var proxyCurType = m_pb_prefs.getIntPref('proxytype');
    m_commonprefs.setIntPref("network.proxy.type", proxyCurType);
    
    if (m_pb_prefs.getBoolPref('launch_swon')) {
        var runcmd = m_pb_prefs.getCharPref('launch_swon_cmd');
        proxybutton_startApp(runcmd);
    }
    
    if (proxyCurType == 2 && m_pb_prefs.getBoolPref('autoreload')) {
        // Autoreload enabled and autoproxy turned on - do it
        proxybutton_autoReloadProxy();
    }
}

function proxybutton_autoReloadProxy() {
    proxybutton_log(1, 'called autoReloadProxy()');
    
    var autoURL = m_commonprefs.getCharPref('network.proxy.autoconfig_url');
    var nsIProtocolProxyService = Components.interfaces.nsIProtocolProxyService;
    var kPROTPROX_CID = '{e9b301c0-e0e4-11D3-a1a8-0050041caf44}';
    
    var pps = Components.classesByID[kPROTPROX_CID].getService(nsIProtocolProxyService);
    pps.configureFromPAC(autoURL);
}

function proxybutton_initPrefObjects() {
    m_commonprefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

    m_pb_prefs = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    m_pb_prefs = m_pb_prefs.getBranch("extensions.proxybutton.");
}

function proxybutton_initPreferences(doc) {
    pb_pref_radio = doc.getElementById('pb_nProxyType');
    pb_pref_reload = doc.getElementById('pb_bReload');
    if (!m_commonprefs) {
        proxybutton_initPrefObjects();
    }
    proxybutton_checkPreferencesExist();
    
    pb_pref_radio.selectedIndex = m_pb_prefs.getIntPref('proxytype')-1;
    pb_pref_reload.checked = m_pb_prefs.getBoolPref('autoreload');
    
    doc.getElementById('pb_bLaunchOn').checked = m_pb_prefs.getBoolPref('launch_swon');
    doc.getElementById('pb_sLaunchOn').value = m_pb_prefs.getCharPref('launch_swon_cmd');
    proxybutton_modifyLaunchOn(doc, m_pb_prefs.getBoolPref('launch_swon'));
    doc.getElementById('pb_bLaunchOff').checked = m_pb_prefs.getBoolPref('launch_swoff');
    doc.getElementById('pb_nLaunchOff').selectedIndex = !m_pb_prefs.getBoolPref('launch_swoff_same')*1;
    doc.getElementById('pb_sLaunchOff').value = m_pb_prefs.getCharPref('launch_swoff_cmd');
    proxybutton_modifyLaunchOff(doc, m_pb_prefs.getBoolPref('launch_swoff'));

}

function proxybutton_modifyLaunchOn(doc, isEnabled) {
    doc.getElementById('pb_sLaunchOn').disabled = !isEnabled;
    doc.getElementById('pb_labLaunchOn').disabled = !isEnabled;
    doc.getElementById('pb_butLaunchOn').disabled = !isEnabled;
}

function proxybutton_modifyLaunchOff(doc, isEnabled) {
    doc.getElementById('pb_radOffType1').disabled = !isEnabled;
    doc.getElementById('pb_radOffType2').disabled = !isEnabled;
    doc.getElementById('pb_radOffLabel1').disabled = !isEnabled;
    doc.getElementById('pb_radOffLabel2').disabled = !isEnabled;
    doc.getElementById('pb_butOff').disabled = !isEnabled;
    doc.getElementById('pb_sLaunchOff').disabled = !isEnabled;
}

function proxybutton_savePreferences(doc) {
    m_pb_prefs.setIntPref('proxytype', doc.getElementById('pb_nProxyType').selectedItem.value);
    m_pb_prefs.setBoolPref('autoreload', doc.getElementById('pb_bReload').checked);
    
    m_pb_prefs.setBoolPref('launch_swon', doc.getElementById('pb_bLaunchOn').checked);
    m_pb_prefs.setCharPref('launch_swon_cmd', doc.getElementById('pb_sLaunchOn').value);

    m_pb_prefs.setBoolPref('launch_swoff', doc.getElementById('pb_bLaunchOff').checked);
    m_pb_prefs.setBoolPref('launch_swoff_same', doc.getElementById('pb_nLaunchOff').selectedItem.value);
    m_pb_prefs.setCharPref('launch_swoff_cmd', doc.getElementById('pb_sLaunchOff').value);
}

function proxybutton_checkPreferencesExist() {
    try {
        m_pb_prefs.getIntPref('proxytype');
    } catch (rErr) {
        // Got exception - it seems that there's no such preference. Smash it in.
        m_pb_prefs.setIntPref('proxytype', 1);
    }

    try {
        m_commonprefs.getCharPref('keyconfig.main.xxx_key__ProxyButton Switch');
    } catch (rErr) {
        // Got exception - it seems that there's no such preference. Smash it in.
        m_commonprefs.setCharPref('keyconfig.main.xxx_key__ProxyButton Switch', '!][][][proxybutton_switchProxy();][');
    }

    try {
        m_pb_prefs.getBoolPref('autoreload');
    } catch (rErr) {
        // Got exception - it seems that there's no such preference. Smash it in.
        m_pb_prefs.setBoolPref('autoreload', 0);
    }
    
    try {
        m_pb_prefs.getBoolPref('launch_swon');
    } catch (rErr) {
        // Got exception so we assume that we don't have preferences for "External program launch" at all
        // so let's add all of them
        m_pb_prefs.setBoolPref('launch_swon', 0);
        m_pb_prefs.setCharPref('launch_swon_cmd', '');
        
        m_pb_prefs.setBoolPref('launch_swoff', 0);
        m_pb_prefs.setBoolPref('launch_swoff_same', 1);
        m_pb_prefs.setCharPref('launch_swoff_cmd', '');
    }
}

function proxybutton_log(nLevel, sMsg) {
    if (m_pb_logger) {
        var rDate = new Date();
        m_pb_logger.log(nLevel, rDate.getTime()+': '+sMsg);
    }
}

function proxybutton_chooseApp(targetElm) {
    const nsIFilePicker = Components.interfaces.nsIFilePicker;
    var gPrefApplicationsBundle = document.getElementById('pb_prefStrings');
    var filePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
    if (filePicker) {
        const FP = Components.interfaces.nsIFilePicker
        var windowTitle = gPrefApplicationsBundle.getString("prefWindowTitle");
        var programsFilter = gPrefApplicationsBundle.getString("prefFilterName");
        
        filePicker.init(window, windowTitle, FP.modeOpen);
        if (navigator.platform == "Win32") {
            filePicker.appendFilter(programsFilter, "*.exe; *.com");
        } else {
            filePicker.appendFilters(FP.filterAll);
        }
        
        var filePicked = filePicker.show();
        if (filePicked == nsIFilePicker.returnOK && filePicker.file) {
            var file = filePicker.file.QueryInterface(Components.interfaces.nsILocalFile);
            targetElm.value = file.path;
            targetElm.select();
        }
    }
}

function proxybutton_startApp(fileName) {
    try {
        var lfile = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
        lfile.initWithPath(fileName);

        if (lfile.isFile() && lfile.isExecutable()) {
            try {
                var process = Components.classes['@mozilla.org/process/util;1'].createInstance(Components.interfaces.nsIProcess);
                process.init(lfile);
                var res = process.run(false, null, 0);
            } catch (e) {
                // huh?
            }
        }
    }
    catch(e) {
        // huh?
    }
    //return data;
}
